local AddonName = "ChatsToMSBT"
local FriendlyAddonName = "Chats To MSBT"

--[[ **************************************************************************
     *  Add On Dependencies version checks                                    *
	 **************************************************************************
]]

local LockVar = AddonName .. "_VerLockOut"

if not ( _G[ LockVar ] ) then
	C2MSBT.Config = {}
	local Config = C2MSBT.Config
	
	-- Config Panel Text Strings
	Config.Text1={
	Title = FriendlyAddonName,
	TitleSub = "Change how the AddOn behaves by setting the options below",
	Enable = "Enable The AddOn to function",
	PerChar = "Save settings per character",
	Guild = "Put Guild chat into MSBT",
	Party = "Put Party chat into MSBT",
	Say = "Put Say chat into MSBT",
	Whispers = "Put whispers into MSBT",
	Raid = "Put Raid chat into MSBT",
	BGs = "Put Battleground chat into MSBT",
	Chats = "Put other chat into MSBT",
	Yell = "Put Yell chat into MSBT",
	Emotes = "Put Emotes into MSBT",
	}

	Config.Text2={
	Title = "Channel List",
	TitleSub = "Select channels to copy to MSBT",
	TitleSub2 = "Chans you are in  / Chans that will go to MSBT if you are in",
	ChanBox = "Channel Name",
	AddButton = "Add",
	DeleteButton = "Delete",
	}

	-- Local text colors
	local yel = "|cFFFFFF00"
	local wht = "|cFFFFFFFF"
	local blu = "|cFF00FFFF"
	local red = "|cFFFF0000"
	local grn = "|cFF00FF00"
	local res = "|r"

	-- Bill's Utils
	local Wait = BillsUtils.Wait
	local ChkBox = BillsUtils.ChkBox
	local ChkBoxSave = BillsUtils.ChkBoxSave
	local CheckClick = BillsUtils.CheckClick
	local SliderMW = BillsUtils.SliderMW


	local X = 16 -- standard Horizontal Spacing
	local Y = 35 -- standard Vertical spacing 26
	local TxtY = 13



	-- General Settings / functions


	--Panel
	Config.panel = CreateFrame( "Frame", AddonName, UIParent )
	Config.panel2 = CreateFrame( "Frame", AddonName.."2" , Config.panel )
	local me = Config.panel
	local me2 = Config.panel2
	me:SetScript("OnLoad", function()
		me.init()
	end)


	me.name = FriendlyAddonName
	me2:SetSize(380,475)
	me2:SetPoint("BOTTOMLEFT", me, "BOTTOMLEFT")
	
	-- Pane title
	local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
	Title:SetPoint( "TOPLEFT", 16, -16 )
	Title:SetText( Config.Text1.Title )
	local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
	SubText:SetPoint( "RIGHT", -32, 0 )
	SubText:SetHeight( 32 )
	SubText:SetJustifyH( "LEFT" )
	SubText:SetJustifyV( "TOP" )
	SubText:SetText( Config.Text1.TitleSub )

-- Scroll Frame
	me.ScrollFrame = CreateFrame("ScrollFrame", AddonName.."ConfigScrollFrame", me, "UIPanelScrollFrameTemplate")
	me.ScrollFrame:SetScrollChild(me2)
	me.ScrollFrame:SetPoint("TOPRIGHT", me ,"TOPRIGHT", -30,- 64)
	me.ScrollFrame:SetPoint("BOTTOMRIGHT", me ,"BOTTOMRIGHT", -30, 10)
	me.ScrollFrame:SetSize(390, 400)


-- Check Boxes & Text
	local last = me2
	local Command = {	"Enable", "PerChar", "Guild", "Party", "Say", "Whispers", "Raid", "BGs", "Chats", "Yell", "Emotes", }

	for x = 1, #Command do
		me[ Command[x] ] = ChkBox( last , AddonName.."Cfg", Command[x] , me2, CheckClick, Config.Text1 )
		last = me[ Command[x] ]
	end
	
--	End of frame



-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- X  Init / Reset the config panel to match current settings                                                     X
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--


	me.Init = function(...)
		local Table = C2MSBT_Settings
		if C2MSBT_SettingsPC.PerChar then
			Table = C2MSBT_SettingsPC
		end
	
		local me = Config.panel

		me.Enable:SetChecked( Table.Enable )
		me.PerChar:SetChecked( C2MSBT_SettingsPC.PerChar )
		me.Guild:SetChecked( Table.Guild )
		me.Party:SetChecked( Table.Party )
		me.BGs:SetChecked( Table.BGs )
		me.Raid:SetChecked( Table.Raid )
		me.Say:SetChecked( Table.Say )
		me.Whispers:SetChecked( Table.Whispers )
		me.Yell:SetChecked( Table.Yell )
		me.Emotes:SetChecked( Table.Emotes )
		me.Chats:SetChecked( Table.Chats )
	end

-- Reset config panel and settings to DEFAULT
	me.Reset = function(...)
		local cur = C2MSBT_Settings
		local def = C2MSBT_Settings_Defaults
		
		if C2MSBT_SettingsPC.PerChar then
			cur = C2MSBT_SettingsPC
			def = C2MSBT_SettingsPC_Defaults
		end

		cur.Enable = def.Enable
		cur.PerChar = C2MSBT_SettingsPC_Defaults.PerChar
		cur.Guild = def.Guild
		cur.Party = def.Party
		cur.BGs = def.BGs
		cur.Raid = def.Raid
		cur.Say = def.Say
		cur.Whispers = def.Whispers
		cur.Yell = def.Yell
		cur.Emotes = def.Emotes
		cur.Chats = def.Chats
		me.Init()
	end



	me.refresh = function(self)
		me.Init()
	end

	me.default = function (self)
		me.Reset()
	end

	me.cancel = function (self)
		me.Init()
	end

	-- Save settings from config panel
	me.okay = function(self)
		ChkBoxSave( Config.panel, "PerChar", C2MSBT_SettingsPC )
		local Table = C2MSBT_Settings
		if C2MSBT_SettingsPC.PerChar then
			Table = C2MSBT_SettingsPC
		end
		
		ChkBoxSave( Config.panel, "Enable", Table) -- Enable CheckBox
		ChkBoxSave( Config.panel, "Guild", Table) -- Guild CheckBox
		ChkBoxSave( Config.panel, "Party", Table) -- Party CheckBox
		ChkBoxSave( Config.panel, "Say", Table) -- Say CheckBox
		ChkBoxSave( Config.panel, "Whispers", Table) -- Whispers CheckBox
		ChkBoxSave( Config.panel, "Yell", Table) -- Yell CheckBox
		ChkBoxSave( Config.panel, "Emotes", Table) -- Emotes CheckBox
		ChkBoxSave( Config.panel, "BGs", Table) -- BGs CheckBox
		ChkBoxSave( Config.panel, "Chats", Table) -- Chats CheckBox
	
		C2MSBT.EventManager()
	end

	-- Register the config panel
	InterfaceOptions_AddCategory( me )


-- ****************************************************************************
-- * Channel List Daughter Panel                                              *
-- ****************************************************************************

	--Panel
	Config.panel3 = CreateFrame( "Frame", AddonName.."Config3", UIParent )
	local me = Config.panel3
	me.InChan = {}
	me.ListenChan = {}

	me.name = Config.Text2.Title
	me.parent = Config.panel.name


	me.ChanBoxUpdate = function( Caller, count)
		if Caller == "ListenChan" then
			local ChanList = C2MSBT_Settings.ChanList
			if C2MSBT_SettingsPC.PerChar then
				ChanList = C2MSBT_SettingsPC.ChanList
			end
			
			local maxcount = #ChanList
			local slider = me.slider:GetValue()
			if count + slider > maxcount then
				me.ChanBox:SetText("")
			else
				me.ChanBox:SetText(ChanList[count + slider])
			end
		elseif Caller == "InChan" then
			local ChanList = { GetChannelList() }
			local maxcount = #ChanList / 2
			if count > maxcount then
				me.ChanBox:SetText("")
			else
				me.ChanBox:SetText(ChanList[count * 2])
			end
		end
	end


	me.ChanDisplayUpdate = function()
		local ChanList = C2MSBT_Settings.ChanList
		if C2MSBT_SettingsPC.PerChar then
			ChanList = C2MSBT_SettingsPC.ChanList
		end
		local maxcount = #ChanList
		local slider = me.slider:GetValue()

		for x = 1 , 10 do
			if x + slider > maxcount then
				me.ListenChan[x]:SetText( " " )
			else
			me.ListenChan[x]:SetText( ChanList[x + slider] )
			end
		end
		me.slider:SetMinMaxValues( 0, (maxcount > 10 and maxcount - 10) or 1 )
	
		local InChanList = { GetChannelList() }
		local InChanListMax = #InChanList /2
	
		for x = 1, 10 do
			if x > InChanListMax then
				me.InChan[x]:SetText( " " )
			else
				me.InChan[x]:SetText( InChanList[x*2] )
			end
		end
	end


	-- Pane title
	local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
	Title:SetPoint( "TOPLEFT", 16, -16 )
	Title:SetText( Config.Text2.Title )
	local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
	SubText:SetPoint( "RIGHT", -32, 0 )
	SubText:SetHeight( 32 )
	SubText:SetJustifyH( "LEFT" )
	SubText:SetJustifyV( "TOP" )
	SubText:SetText( Config.Text2.TitleSub  )
	local SubText2 = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	SubText2:SetPoint( "TOPLEFT", TitleSub, "BOTTOMLEFT", 0, -8 )
	SubText2:SetPoint( "RIGHT", -32, 0 )
	SubText2:SetHeight( 32 )
	SubText2:SetJustifyH( "LEFT" )
	SubText2:SetJustifyV( "TOP" )
	SubText2:SetText( Config.Text2.TitleSub2  )
	
	local last = me
	local width = 150 

	for x = 1, 10 do
		me.InChan[x] = CreateFrame("Button", AddonName.."InChanListButton"..tostring(x), me, "UIPanelButtonTemplate" )
		if last == me then
			me.InChan[x]:SetPoint("TOPLEFT", last, "TOPLEFT", 20, -60 )
		else
			me.InChan[x]:SetPoint("TOPLEFT", last, "BOTTOMLEFT" )
		end
		me.InChan[x]:SetSize( width , 20)
		me.InChan[x]:SetText( " " )
		me.InChan[x].count = x
		me.InChan[x]:SetScript("OnClick", function(self, button, down)
			if (button ~= "LeftButton") then
				return
			end
			PlaySound( "GAMEGENERICBUTTONPRESS" )
			me.ChanBoxUpdate( "InChan", self.count )
			return
		end)
		last = me.InChan[x]
	
		me.ListenChan[x] = CreateFrame("Button", AddonName.."ListenChanListButton"..tostring(x), me, "UIPanelButtonTemplate" )
		me.ListenChan[x]:SetPoint("TOPLEFT", last, "TOPRIGHT", 20, 0 )
		me.ListenChan[x]:SetSize( width , 20)
		me.ListenChan[x]:SetText( " " )
		me.ListenChan[x].count = x
		me.ListenChan[x]:SetScript("OnClick", function(self, button, down)
			if (button ~= "LeftButton") then
				return
			end
			PlaySound( "GAMEGENERICBUTTONPRESS" )
			me.ChanBoxUpdate( "ListenChan", self.count )
			return
		end)
	end


	me.slider = CreateFrame( "Slider", AddonName.."ChanListSlider", me, "OptionsSliderTemplate" )
	me.slider:SetMinMaxValues( 0, 1 )
	me.slider:SetOrientation("VERTICAL")
	me.slider:SetPoint("TOPLEFT", me.ListenChan[1] ,"TOPRIGHT", 5 , 0)
	me.slider:SetPoint("BOTTOMLEFT", me.ListenChan[10] ,"BOTTOMRIGHT", 5 , 0)
	me.slider:SetValueStep( 1 )
	me.slider:SetWidth( 16 )	
	me.slider:SetScript( "OnValueChanged", function( self )
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		me.ChanDisplayUpdate()
	end)
	getglobal(me.slider:GetName() .. 'Low'):SetText( " " )
	getglobal(me.slider:GetName() .. 'High'):SetText( " " )
--	getglobal(slider:GetName() .. 'Text'):SetText(TextTable[ Name ]); --Sets the "title" text (top-centre of slider).
	me.slider:SetScript("OnMouseWheel", function(self, delta)
		SliderMW(self, -delta)
	end)

	me.ChanBox = CreateFrame( "EditBox", AddonName.."ChanEditbox", me, "InputBoxTemplate" )
	me.ChanBox:SetFontObject("ChatFontNormal")
	me.ChanBox:SetTextInsets(0, 0, 3, 3)
	me.ChanBox:SetPoint("BOTTOMLEFT", me , "BOTTOMLEFT", 30 , 50 )
	me.ChanBox:SetPoint("RIGHT", -32, 0)
	me.ChanBox:SetHeight(19)
	me.ChanBox:SetWidth(50)
	me.ChanBox:SetAutoFocus(false)
	me.ChanBox:SetMaxLetters( 254 )
	me.ChanBox:SetScript("OnEnterPressed" , function(self)
		self:ClearFocus()
	end)
	me.ChanBox:SetScript("OnEscapePressed", function(self)
		self:SetText( "" )
		self:ClearFocus()
	end)

	me.ChanBox.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	me.ChanBox.Text:SetPoint( "BOTTOMLEFT", me.ChanBox , "BOTTOMLEFT", 0 , Y/4 )
	me.ChanBox.Text:SetPoint( "RIGHT", -32, 0 )
	me.ChanBox.Text:SetHeight( 32 )
	me.ChanBox.Text:SetJustifyH( "LEFT" )
	me.ChanBox.Text:SetJustifyV( "TOP" )
	me.ChanBox.Text:SetText( Config.Text2.ChanBox )

	me.AddButton = CreateFrame("Button", AddonName.."ChanListAddButton", me, "UIPanelButtonTemplate" )
	me.AddButton:SetPoint("BOTTOMLEFT", me, "BOTTOMLEFT", 20 , 20 )
	me.AddButton:SetSize( 150, 25)
	me.AddButton:SetText(Config.Text2.AddButton)
	me.AddButton:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		C2MSBT.Channel("add", me.ChanBox:GetText() )
		me.ChanBox:SetText("")
		me.ChanBox:ClearFocus()
		me.ChanDisplayUpdate()
	return
	end)

	me.DeleteButton = CreateFrame("Button", AddonName.."ChanListDeleteButton", me, "UIPanelButtonTemplate" )
	me.DeleteButton:SetPoint("BOTTOMRIGHT", me, "BOTTOMRIGHT", -20 , 20 )
	me.DeleteButton:SetSize( 150, 25)
	me.DeleteButton:SetText("Delete")
	me.DeleteButton:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		C2MSBT.Channel("rem", me.ChanBox:GetText() )
		me.ChanBox:SetText("")
		me.ChanBox:ClearFocus()
		me.ChanDisplayUpdate()
		return
	end)

	me.refresh= function( self )
		me.slider:SetValue(0)
		me.ChanDisplayUpdate()
	end


	InterfaceOptions_AddCategory( me )


end -- end of huge VerLockOut if so addon doesn't load if Bill's Utils is out of date

